# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xazurepackadmin`](#dsc_xazurepackadmin): The DSC xAzurePackAdmin resource type. Automatically generated from version 1.4.0.0
* [`dsc_xazurepackdatabasesetting`](#dsc_xazurepackdatabasesetting): The DSC xAzurePackDatabaseSetting resource type. Automatically generated from version 1.4.0.0
* [`dsc_xazurepackfqdn`](#dsc_xazurepackfqdn): The DSC xAzurePackFQDN resource type. Automatically generated from version 1.4.0.0
* [`dsc_xazurepackidentityprovider`](#dsc_xazurepackidentityprovider): The DSC xAzurePackIdentityProvider resource type. Automatically generated from version 1.4.0.0
* [`dsc_xazurepackrelyingparty`](#dsc_xazurepackrelyingparty): The DSC xAzurePackRelyingParty resource type. Automatically generated from version 1.4.0.0
* [`dsc_xazurepackresourceprovider`](#dsc_xazurepackresourceprovider): The DSC xAzurePackResourceProvider resource type. Automatically generated from version 1.4.0.0
* [`dsc_xazurepacksetup`](#dsc_xazurepacksetup): The DSC xAzurePackSetup resource type. Automatically generated from version 1.4.0.0
* [`dsc_xazurepackupdate`](#dsc_xazurepackupdate): The DSC xAzurePackUpdate resource type. Automatically generated from version 1.4.0.0

## Resource types

### <a name="dsc_xazurepackadmin"></a>`dsc_xazurepackadmin`

The DSC xAzurePackAdmin resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepackadmin` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

An enumerated value that describes if the principal is an Azure Pack admin. Present {default}   Absent    

##### `dsc_sqlinstance`

Data type: `Optional[String]`

Database instance for the Azure Pack databases.

#### Parameters

The following parameters are available in the `dsc_xazurepackadmin` type.

* [`dsc_azurepackadmincredential`](#dsc_azurepackadmincredential)
* [`dsc_dbuser`](#dsc_dbuser)
* [`dsc_principal`](#dsc_principal)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_sqlserver`](#dsc_sqlserver)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_azurepackadmincredential"></a>`dsc_azurepackadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="dsc_dbuser"></a>`dsc_dbuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

SQL user to be used to create the database if the SetupCredential cannot be used.

##### <a name="dsc_principal"></a>`dsc_principal`

namevar

Data type: `String`

The Azure Pack admin principal.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_sqlserver"></a>`dsc_sqlserver`

namevar

Data type: `String`

Database server for the Azure Pack databases.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xazurepackdatabasesetting"></a>`dsc_xazurepackdatabasesetting`

The DSC xAzurePackDatabaseSetting resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepackdatabasesetting` type.

##### `dsc_sqlinstance`

Data type: `Optional[String]`

Database instance for the Azure Pack databases.

##### `dsc_value`

Data type: `String`

Specifies the value of the setting.

#### Parameters

The following parameters are available in the `dsc_xazurepackdatabasesetting` type.

* [`dsc_azurepackadmincredential`](#dsc_azurepackadmincredential)
* [`dsc_dbuser`](#dsc_dbuser)
* [`dsc_name`](#dsc_name)
* [`dsc_namespace`](#dsc_namespace)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_sqlserver`](#dsc_sqlserver)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_azurepackadmincredential"></a>`dsc_azurepackadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="dsc_dbuser"></a>`dsc_dbuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

SQL user to be used to create the database if the SetupCredential cannot be used.

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the setting.

##### <a name="dsc_namespace"></a>`dsc_namespace`

namevar

Data type: `Enum['AdminSite', 'TenantSite']`

Specifies the namespace.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_sqlserver"></a>`dsc_sqlserver`

namevar

Data type: `String`

Database server for the Azure Pack databases.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xazurepackfqdn"></a>`dsc_xazurepackfqdn`

The DSC xAzurePackFQDN resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepackfqdn` type.

##### `dsc_fullyqualifieddomainname`

Data type: `String`

Specifies a Fully Qualified Domain Name (FQDN).

##### `dsc_port`

Data type: `Optional[Integer[0, 65535]]`

Specifies a port number.

##### `dsc_sqlinstance`

Data type: `Optional[String]`

Database instance for the Azure Pack databases.

##### `dsc_sqlserver`

Data type: `String`

Database server for the Azure Pack databases.

#### Parameters

The following parameters are available in the `dsc_xazurepackfqdn` type.

* [`dsc_azurepackadmincredential`](#dsc_azurepackadmincredential)
* [`dsc_dbuser`](#dsc_dbuser)
* [`dsc_namespace`](#dsc_namespace)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_azurepackadmincredential"></a>`dsc_azurepackadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="dsc_dbuser"></a>`dsc_dbuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

SQL user to be used to create the database if the SetupCredential cannot be used.

##### <a name="dsc_namespace"></a>`dsc_namespace`

namevar

Data type: `Enum['AdminSite', 'AuthSite', 'TenantSite', 'WindowsAuthSite']`

Specifies a namespace.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xazurepackidentityprovider"></a>`dsc_xazurepackidentityprovider`

The DSC xAzurePackIdentityProvider resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepackidentityprovider` type.

##### `dsc_fullyqualifieddomainname`

Data type: `String`

Specifies a Fully Qualified Domain Name (FQDN).

##### `dsc_port`

Data type: `Optional[Integer[0, 65535]]`

Specifies a port number.

##### `dsc_sqlinstance`

Data type: `Optional[String]`

Database instance for the Azure Pack databases.

##### `dsc_sqlserver`

Data type: `String`

Database server for the Azure Pack databases.

#### Parameters

The following parameters are available in the `dsc_xazurepackidentityprovider` type.

* [`dsc_azurepackadmincredential`](#dsc_azurepackadmincredential)
* [`dsc_dbuser`](#dsc_dbuser)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_target`](#dsc_target)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_azurepackadmincredential"></a>`dsc_azurepackadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="dsc_dbuser"></a>`dsc_dbuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

SQL user to be used to create the database if the SetupCredential cannot be used.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_target"></a>`dsc_target`

namevar

Data type: `Enum['Membership', 'Windows']`

Specifies the target site.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xazurepackrelyingparty"></a>`dsc_xazurepackrelyingparty`

The DSC xAzurePackRelyingParty resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepackrelyingparty` type.

##### `dsc_port`

Data type: `Optional[Integer[0, 65535]]`

Specifies a port number.

##### `dsc_sqlinstance`

Data type: `Optional[String]`

Database instance for the Azure Pack databases.

##### `dsc_sqlserver`

Data type: `String`

Database server for the Azure Pack databases.

#### Parameters

The following parameters are available in the `dsc_xazurepackrelyingparty` type.

* [`dsc_azurepackadmincredential`](#dsc_azurepackadmincredential)
* [`dsc_dbuser`](#dsc_dbuser)
* [`dsc_fullyqualifieddomainname`](#dsc_fullyqualifieddomainname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_target`](#dsc_target)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_azurepackadmincredential"></a>`dsc_azurepackadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="dsc_dbuser"></a>`dsc_dbuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

SQL user to be used to create the database if the SetupCredential cannot be used.

##### <a name="dsc_fullyqualifieddomainname"></a>`dsc_fullyqualifieddomainname`

namevar

Data type: `String`

Specifies a Fully Qualified Domain Name (FQDN).

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_target"></a>`dsc_target`

namevar

Data type: `Enum['Admin', 'Tenant']`

Specifies the target site.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xazurepackresourceprovider"></a>`dsc_xazurepackresourceprovider`

The DSC xAzurePackResourceProvider resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepackresourceprovider` type.

##### `dsc_adminauthenticationmode`

Data type: `Optional[Enum['None', 'Basic', 'Windows']]`

Specifies the administrative authentication mode for a resource provider.

##### `dsc_adminauthenticationusername`

Data type: `Optional[String]`

Output for the administrative user name.

##### `dsc_adminforwardingaddress`

Data type: `Optional[String]`

Specifies an administrative forwarding address for a resource provider.

##### `dsc_adminuri`

Data type: `String`

Specifies the URI of the Windows Azure Pack administrator API.

##### `dsc_allowanonymousaccess`

Data type: `Optional[Boolean]`

Specifies the URI of the Windows Azure Pack administrator API.

##### `dsc_allowmultipleinstances`

Data type: `Optional[Boolean]`

Indicates that the cmdlet allows multiple instances of the resource provider.

##### `dsc_authenticationsite`

Data type: `String`

URL of the authentication site.

##### `dsc_displayname`

Data type: `Optional[String]`

Specifies the display name of a resource provider.

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Enables the resource provider.

##### `dsc_healthcheckauthenticationmode`

Data type: `Optional[Enum['None', 'Basic', 'Windows']]`

Specifies the health check authentication mode for a resource provider.

##### `dsc_healthcheckauthenticationusername`

Data type: `Optional[String]`

Output for the health check user name.

##### `dsc_healthcheckforwardingaddress`

Data type: `Optional[String]`

Specifies the health check forwarding address for a resource provider.

##### `dsc_instancedisplayname`

Data type: `Optional[String]`

Specifies a display name for an instance of a resource provider.

##### `dsc_instanceid`

Data type: `Optional[String]`

Specifies an ID for an instance of a resource provider.

##### `dsc_maxquotaupdatebatchsize`

Data type: `Optional[String]`

Specifies the number of subscriptions that can be updated in a single request.

##### `dsc_notificationauthenticationmode`

Data type: `Optional[Enum['None', 'Basic', 'Windows']]`

Specifies the notification authentication mode for a resource provider.

##### `dsc_notificationauthenticationusername`

Data type: `Optional[String]`

Output for the notification user name.

##### `dsc_notificationforwardingaddress`

Data type: `Optional[String]`

Specifies the notification forwarding address of a resource provider.

##### `dsc_passthroughenabled`

Data type: `Optional[Boolean]`

Indicates whether the resource provider supports API pass-through.

##### `dsc_subscriptionstatuspollinginterval`

Data type: `Optional[String]`

Specifies the time interval at which the management service polls the resource provider for subscription status updates.

##### `dsc_tenantauthenticationmode`

Data type: `Optional[Enum['None', 'Basic', 'Windows']]`

Specifies the tenant authentication mode for a resource provider.

##### `dsc_tenantauthenticationusername`

Data type: `Optional[String]`

Output for the tenant user name.

##### `dsc_tenantforwardingaddress`

Data type: `Optional[String]`

Specifies the tenant forwarding address of a resource provider.

##### `dsc_tenantsourceuritemplate`

Data type: `Optional[String]`

Specifies the tenant source URI template of a resource provider.

##### `dsc_tenanttargeturitemplate`

Data type: `Optional[String]`

Specifies the tenant target URI template of a resource provider.

##### `dsc_type`

Data type: `Optional[Enum['Standard', 'UsageProvider', 'CloudServiceProvider']]`

Specifies the type of the resource provider.

##### `dsc_usageauthenticationmode`

Data type: `Optional[Enum['None', 'Basic', 'Windows']]`

Specifies the usage authentication mode for a resource provider.

##### `dsc_usageauthenticationusername`

Data type: `Optional[String]`

Output for the usage user name.

##### `dsc_usageforwardingaddress`

Data type: `Optional[String]`

Specifies the tenant forwarding address of a resource provider.

#### Parameters

The following parameters are available in the `dsc_xazurepackresourceprovider` type.

* [`dsc_adminauthenticationuser`](#dsc_adminauthenticationuser)
* [`dsc_azurepackadmincredential`](#dsc_azurepackadmincredential)
* [`dsc_healthcheckauthenticationuser`](#dsc_healthcheckauthenticationuser)
* [`dsc_name`](#dsc_name)
* [`dsc_notificationauthenticationuser`](#dsc_notificationauthenticationuser)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_tenantauthenticationuser`](#dsc_tenantauthenticationuser)
* [`dsc_usageauthenticationuser`](#dsc_usageauthenticationuser)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_adminauthenticationuser"></a>`dsc_adminauthenticationuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies, as a PSCredential object, an administrative user name and password to connect to a resource provider.

##### <a name="dsc_azurepackadmincredential"></a>`dsc_azurepackadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="dsc_healthcheckauthenticationuser"></a>`dsc_healthcheckauthenticationuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies, as a PSCredential object, a health check user name and password to connect to a resource provider.

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of a resource provider.

##### <a name="dsc_notificationauthenticationuser"></a>`dsc_notificationauthenticationuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies, as a PSCredential object, a notification user name and password to connect to a resource provider.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_tenantauthenticationuser"></a>`dsc_tenantauthenticationuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies, as a PSCredential object, a tenant user name and password to connect to a resource provider.

##### <a name="dsc_usageauthenticationuser"></a>`dsc_usageauthenticationuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies, as a PSCredential object, a usage user name and password to connect to a resource provider.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xazurepacksetup"></a>`dsc_xazurepacksetup`

The DSC xAzurePackSetup resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepacksetup` type.

##### `dsc_enableceip`

Data type: `Optional[String]`

Enable Customer Experience Improvement Program.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_sqlinstance`

Data type: `Optional[String]`

Database instance for the Azure Pack databases.

##### `dsc_sqlserver`

Data type: `Optional[String]`

Database server for the Azure Pack databases.

#### Parameters

The following parameters are available in the `dsc_xazurepacksetup` type.

* [`dsc_action`](#dsc_action)
* [`dsc_dbuser`](#dsc_dbuser)
* [`dsc_passphrase`](#dsc_passphrase)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_role`](#dsc_role)
* [`dsc_setupcredential`](#dsc_setupcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_action"></a>`dsc_action`

namevar

Data type: `Enum['Install', 'Initialize']`

Install or initialize.

##### <a name="dsc_dbuser"></a>`dsc_dbuser`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

SQL user to be used to create the database if the SetupCredential cannot be used.

##### <a name="dsc_passphrase"></a>`dsc_passphrase`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Passphrase for the Azure Pack deployment.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_role"></a>`dsc_role`

namevar

Data type: `Enum['Admin API', 'Tenant API', 'Tenant Public API', 'SQL Server Extension', 'MySQL Extension', 'Admin Site', 'Admin Authentication Site', 'Tenant Site', 'Tenant Authentication Site']`

The Azure Pack role to be installed or initialized.

##### <a name="dsc_setupcredential"></a>`dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xazurepackupdate"></a>`dsc_xazurepackupdate`

The DSC xAzurePackUpdate resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xazurepackupdate` type.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

#### Parameters

The following parameters are available in the `dsc_xazurepackupdate` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_role`](#dsc_role)
* [`dsc_setupcredential`](#dsc_setupcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_role"></a>`dsc_role`

namevar

Data type: `Enum['Admin API', 'Tenant API', 'Tenant Public API', 'SQL Server Extension', 'MySQL Extension', 'Admin Site', 'Admin Authentication Site', 'Tenant Site', 'Tenant Authentication Site']`

The Azure Pack role to be updated.

##### <a name="dsc_setupcredential"></a>`dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

